#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
//
#include "src/pra.h"
#include "src/pra_st.h"
//
#include "src/dos/dos_irq.h"
#include "src/dos/pra_du.h"

#include "src/dos/pra_dt.h"
USING_namespace(NprA)

//forward
//static void interrupt timer_IRQ_handler_entry();

//
Tdec_timer
	REF_namespace(NprA)
	timer_no_reply[DOS_COM_PORTS],

	REF_namespace(NprA)
	timer_keep_alive[DOS_COM_PORTS],

	REF_namespace(NprA)
	timer_tx_line[DOS_COM_PORTS];

//
Tdos_timer
	REF_namespace(NprA)
	//   IRQ timer  
	dos_timer;

//**********************
//  IRQ     Tdos_timer
static void interrupt timer_IRQ_handler_entry(){ register Tdos_timer *const p= &dos_timer; p[0].IRQ_handler_body(); }

//
void
	REF_namespace(NprA)
	init_dos_timer(
		){
	//
	register uint
		tmp= DOS_COM_PORTS;

	if( !tmp )return;
	if( tmp > 4 )err(ERR_BOUND, "DOS_COM_PORTS > 4", "init_dos_timer");

	//
	if( atexit(atexit_dos_timer) )err(ERR_BADRES, "atexit(atexit_dos_timer)", "init_dos_timer");

	// Tdec_timer::init_value 
	//   conf      [DOS_COM_PORTS]
	for(uint i= 0; i < DOS_COM_PORTS; ++i){ 

		timer_no_reply[i]= 		Tdec_timer( dug[i].pra_conf.pri_init_timer_no_reply, 0);
		timer_keep_alive[i]= 	Tdec_timer( dug[i].pra_conf.pri_init_timer_keep_alive, 0);
		timer_tx_line[i]= 		Tdec_timer( dug[i].pra_conf.init_timer_tx_line, 0);
	}

	//    IRQ    Tdos_timer
	dos_timer.set_IRQ_handler_entry(timer_IRQ_handler_entry);
	
	//reinit:   IRQ timer 
	dos_timer.set_irq_handler();
}

void
	REF_namespace(NprA)
	atexit_dos_timer(
		){

	//  IRQ timer
	dos_timer.restore_irq_handler();
}
