#ifndef PRA_H
#define PRA_H
//   

//namespace NprA{
BEGIN_namespace(NprA)

//  
	// 
	//    ASCII    0-31
	//     
	//     DLE-     
	enum{ PR_DLE= 0x10U };
	enum{ PR_SYN= 0x16U };

	//  DLE  (   DLE)
	//ASCII        32-126
	//    PR_DLE_*
	enum{ PR_DLE_DLE= 0x30U };
	enum{ PR_DLE_SYN= 0x31U };

	//  DLE     
	//    

//     
enum{
	// 
	PE_OK= 0,

//   RS232
	
	//    
	// UART     RS232 (   ..)
	//  A      
	//  UART     RS232 
	// (..        -)
	PE_RX_LINE,

	// UART   (     )
	//      tx_line 
	//UART       RS232 (     ..)
	PE_TX_LINE,

	// UART
	// UART      
	//  UART       A
	PE_UART,

//    
//      

	//    UART
	//    
	//      
	//	         
	//	       
	PE_RX_BUF_OVER= 0x10U,

	//    
	//  PE_RX_BUF_OVER,      
	//   IRQ rx  
	//PE_RX_BUF_OVER_2,
	//	  rx    ,     
	//	   PE_RX_BUF_OVER      
	//	     

	//   
	//(        )
	//     
	//          
	PE_RX_SPURIOUS,

//    DLE 
	PE_RX_DLE_UNK,

//   
//       
//   no_reply
	PE_TX_NO_REPLY= 0x20U
};

//    
//     
	// ,       
	//   
	//   ,       
	//   PR_TIMER_0     0
	enum{ PR_TIMER_0= 0 };
	
	// ,       
	//     (  )
	//   ,       
	// PR_TIMER_INF          (  -1)
	enum{ PR_TIMER_INF= -1 };

	//  ,           
	//        
	//   TprA_conf  "bool is_dis_timer_*"

//    
class TprA_conf{
//  
public:
	//       (ms)
	enum{ DEF_timer_step= 5 };

	//  (ms)
	ureg16
		//     
		//    timer_step
		timer_step;

	//    
	//  tx_line
	ureg16
		init_timer_tx_line;

	//       
		//      
		//     

	//
		//     "    " 
		// is_*drop_RX_*  
		//       
		// else   " " 
		//      
		//     
	bool
		//     (PE_RX_BUF_OVER)
		//   , 
		//    , 
		//   
		is_drop_RX_BUF_OVER,

		//         (PE_RX_SPURIOUS)
		//   ,   , 
		//   
		is_drop_RX_SPURIOUS;
		
		//     "    " 
		// is_*bypass_RX_*  
		//       
		// else   " " 
		//      
		//     
	bool
		//  DLE   
		//       , 
		//  ,    
		is_bypass_RX_DLE_UNK,
		
		//       RS232 (   ..)
		//       , 
		//  ,    
		is_bypass_RX_LINE;

	//
		//     "    " 
		// is_*drop_TX_*   
		//       
		// else   " " 
		//      
		//     
	bool
    	//   tx_line
		//..          RS232 (  UART) 
    	//   , 
    	//    , 
    	//    
		is_drop_TX_LINE;

//  
public:
	//    
	//  no_reply
	ureg16
		pri_init_timer_no_reply;

	//    
	//  keep_alive
	ureg16
		pri_init_timer_keep_alive;

	//       

	//
		//     "    " 
		// is_*drop_TX_*   
		//       
		// else   " " 
		//      
		//     
	bool
    	//   no_reply 
    	//   , 
    	//     
    	//    
		is_pri_drop_TX_NO_REPLY;

//  
public:
	//  IRQ  COM XT 
	// poll    
	//	        (HPET) 
	//	   100   1  
	bool
		is_sec_poll_mode;

public:
	//     ".ini" 
	// : '{' (<_> ( ureg8*) '=' <> ( ureg16) ';')* '}'

	//       
	// 0       
	bool
		read(FILE *fi);
	
	//      
	// 0       
	bool
		write(FILE *fo);

public:
	TprA_conf();
};

// ureg8         
//  "raw   "  "  "
	
	//raw   
	typedef ureg8 t_prot_ch;
	//  fi   (fi -> -> tx COM   )
	typedef ureg8 t_fi_ch;
	//  fo   (rx COM   -> -> fo )
	typedef ureg8 t_fo_ch;

//namespace NprA
END_namespace(NprA)
#endif