//     ".ini" 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/pra.h"
USING_namespace(NprA)

//namespace{
BEGIN_namespace_a

static
char
	//  
	buf[40+1];

//namespace
//}
END_namespace_a

//
bool
	REF_namespace(NprA)
	TprA_conf::
	read(
		FILE *fi
		){

	//
	if(!fi)err(ERR_ZPTR,"fi","TprA_conf::read");

	// {str,val}
	ureg16
		val;
	char
		str[32+2];

	long
		//   
		fpos;

	// : '{' (<_> ( ureg8*) '=' <> ( ureg16) ';')* '}'
	//  '{'
	if( fscanf(fi, " %1[{]", str) != 1 ){
		// 
		if( feof(fi) )return 1;

		fgets(buf, sizeof(buf), fi);	
		err(ERR_BADPAR,"get '{'","TprA_conf::read",buf);
	}

	// (...)*    
	for(;;){

		//   
		fpos= ftell(fi); if(fpos == -1L)err(ERR_FILE,"ftell","TprA_conf::read");

		//  (...)* 
		memset(str,0,sizeof(str));
		if( fscanf(fi, " %32[0-9a-zA-Z_] = %hd ;", str, &val) != 2 ){

			// 
			if( feof(fi) )return 1;

			//  ,     '}'
			if( fseek(fi,fpos,SEEK_SET) )err(ERR_FILE,"fseek","TprA_conf::read");
			if( fscanf(fi, " %1[}]", buf) == 1 ){ 
			
				//   {}
				return 1;
			}

			//    '}', 
			if( fseek(fi,fpos,SEEK_SET) )err(ERR_FILE,"fseek","TprA_conf::read");
			fgets(buf, sizeof(buf), fi);	
			err(ERR_BADPAR,"get '}'","TprA_conf::read",buf);
		}

		//  {str, val}     (...)* 
		//  
		if( !strcmp("timer_step",str) ){ 						timer_step= val;
		}else if( !strcmp("init_timer_tx_line",str) ){ 			init_timer_tx_line= val;
		}else if( !strcmp("is_drop_RX_BUF_OVER",str) ){ 		is_drop_RX_BUF_OVER= (val? 1:0);
		}else if( !strcmp("is_drop_RX_SPURIOUS",str) ){ 		is_drop_RX_SPURIOUS= (val? 1:0);
		}else if( !strcmp("is_bypass_RX_DLE_UNK",str) ){ 		is_bypass_RX_DLE_UNK= (val? 1:0); 
		}else if( !strcmp("is_bypass_RX_LINE",str) ){ 			is_bypass_RX_LINE= (val? 1:0);
		}else if( !strcmp("is_drop_TX_LINE",str) ){				is_drop_TX_LINE= (val? 1:0);

		//primary
		}else if( !strcmp("pri_init_timer_no_reply",str) ){		pri_init_timer_no_reply= val;
		}else if( !strcmp("pri_init_timer_keep_alive",str) ){	pri_init_timer_keep_alive= val;
		}else if( !strcmp("is_pri_drop_TX_NO_REPLY",str) ){		is_pri_drop_TX_NO_REPLY= (val? 1:0);

		//secondary
		}else if( !strcmp("is_sec_poll_mode",str) ){			is_sec_poll_mode= (val? 1:0);
		
		//unknown {str, val} 
		}else {
			sprintf(buf,"%s = %hd;",str,val);
			err(ERR_BADPAR,"unknown {str, val}","TprA_conf::read",buf);
		}
	}
}

//
bool
	REF_namespace(NprA)
	TprA_conf::
	write(
		FILE *fo
		){

	//
	if(!fo)err(ERR_ZPTR,"fi","TprA_conf::write");

	//  '{'
	fprintf(fo,"{\n");

	// 
	fprintf(fo,"timer_step = %hu;\n", 					timer_step );
	fprintf(fo,"init_timer_tx_line = %hu;\n", 			init_timer_tx_line );
	fprintf(fo,"is_drop_RX_BUF_OVER = %hu;\n", 			is_drop_RX_BUF_OVER );
	fprintf(fo,"is_drop_RX_SPURIOUS = %hu;\n", 			is_drop_RX_SPURIOUS );
	fprintf(fo,"is_bypass_RX_DLE_UNK = %hu;\n", 		is_bypass_RX_DLE_UNK );
	fprintf(fo,"is_bypass_RX_LINE = %hu;\n", 			is_bypass_RX_LINE );
	fprintf(fo,"is_drop_TX_LINE = %hu;\n", 				is_drop_TX_LINE );

	fprintf(fo,"pri_init_timer_no_reply = %hu;\n", 		pri_init_timer_no_reply );
	fprintf(fo,"pri_init_timer_keep_alive = %hu;\n", 	pri_init_timer_keep_alive );
	fprintf(fo,"is_pri_drop_TX_NO_REPLY = %hu;\n", 		is_pri_drop_TX_NO_REPLY );

	fprintf(fo,"is_sec_poll_mode = %hu;\n", 			is_sec_poll_mode );

	//  '}'
	fprintf(fo,"}\n");

	return 1;
}
