//    windows (vs version) 
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <signal.h>

//#include <unistd.h>
#include <windows.h>
#include <process.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/dec_tm.h"
#include "src/pra.h"
USING_namespace(NprA)

//
BEGIN_namespace_a

	//  main     
FILE	
	//   ()
	//*fc= 0, 
	*fcr= 0, 
	*fcw= 0, 
	//  
	*fi= 0,
	//  
	*fo= 0;

void
	//     mingw 
	SIGINT_handler(
		int sig
		){

	//   (   abort)
	//fclose(fo);
	//  
	fprintf(stderr,"\n");

	exit(0);
}

//
class Tcmdline_params{
public:
	char const
		//   ()
		*fc_fname,
		//  
		*fi_fname,
		//  
		*fo_fname;
	
	bool
		//primary/secondary prA device
		is_pri;

public:
		Tcmdline_params(
			): 
			fc_fname("//./pipe/dos1"),
			fi_fname("./isw"),
			fo_fname("./osw"),
			is_pri(1)
			{
	}
};
Tcmdline_params
	cmdline_params;

void
	umsg(){

	fprintf(stderr,
		"cmdline: -p|-s [port ]\n" //[ifile [ofile ]]]\n"
		"\t-p|-s\t\tprimary|secondary device (default '%s')\n"
		"\tport\t\tAUX port (default '%s')\n"
		//"\tifile\t\tfile to read and transfer(default '%s')\n"
		//"\tofile\t\tfile to receive and append(default '%s')\n"
		,
		(cmdline_params.is_pri? "-p": "-s"),
		cmdline_params.fc_fname
		//cmdline_params.fi_fname,
		//cmdline_params.fo_fname
		);
}

TprA_conf
	pra_conf;

//
//   tx_no_reply
Tdec_timer
	timer_tx_no_reply,
	timer_tx_line;

//  winapi
void
	win_err(
		DWORD const last,
		ushort const e,
		char const *const msg=0,
		char const *const who=0
			){
	
	static 
	char 
		last_buf[256]; 
	
	memset(last_buf, 0, sizeof(last_buf));
	_snprintf(last_buf, 10, "%d", last); //last_buf[sizeof(last_buf)-1]= 0;

	err(ERR_FILE, msg, who, last_buf); 
}

//
//blocking read console into struct { is_rx_console, rx_console_data };
bool
	volatile
	//read_console_thread       
	//     rx_console_data   
	is_rx_console= 0;

int
	volatile
	//read_console_thread       is_rx_console
	rx_console_data= 0;

//thread to read
void	
	__cdecl 
	read_console_thread(
		void *
		){
	//if(!fi)PR_SYN
	//tx_ch= fi? fgetc(fi): PR_SYN; 
	//if(tx_ch == EOF){ if( feof(fi) )tx_ch= PR_SYN; else err(ERR_FILE,"fgetc fi","main"); }
	
	for(;;){
		//wait rx buf empty
		while(is_rx_console){ 
		//?? Sleep(30)   WaitForSingleObject(e_rx_console)
			Sleep(30); 
		}

		//blocking read next data from stdin
		rx_console_data= fgetc(stdin);
		is_rx_console= 1;
		//??set signaled (e_rx_console)
	}
}

//
END_namespace_a

//
int
	main(
		int argc,
		char *argv[]
		){

	//
	srand( time(0) );

	if( setvbuf(stdin, 0, _IONBF, 0) ){ fprintf(stderr,"%s: setvbuf stdin\n", "error"); exit(1); }
	if( setvbuf(stdout, 0, _IONBF, 0) ){ fprintf(stderr,"%s: setvbuf stdout\n", "error"); exit(1); }

	//     ini ,  
	{
	char const 
		*const ini_fname= "pra_w.ini";

	for(;;){
		FILE 
			*ft= fopen(ini_fname,"rb"); 
		
		// ini 
		if(!ft){
			//  ini     ,  
			ft= fopen(ini_fname,"ab"); if(!ft)break;
			
			//
			pra_conf.write(ft);
			fclose(ft);
			break;
		}
	
		// ini ,  
		pra_conf.read(ft);
		fclose(ft);
		break;
	}}

	//
	fprintf(stderr,	
		"test protocol A for vs win\n"
		);

	// ctrl+c   
	signal(SIGINT, SIGINT_handler);

	fprintf(stderr,	
		"press 'ctrl+c' to terminate program\n"
		);

	//parse cmdline
	switch(argc){
	#if 0
	case 5:
		cmdline_params.fo_fname= argv[4];
		//next case
	case 4:
		cmdline_params.fi_fname= argv[3];
		//next case
	#endif
	case 3:
		cmdline_params.fc_fname= argv[2];
		//next case
	case 2:
		{
		char
			is_ok= 0;

		if(argv[1][0] == '-')
		switch(argv[1][1]){
			case 's': case 'S': cmdline_params.is_pri= 0; is_ok= 1; break;
			case 'p': case 'P': cmdline_params.is_pri= 1; is_ok= 1; break;
		}
		
		if(!is_ok){ umsg(); err(ERR_BADPAR, "expected -p|-s", argv[1]); }
		}
		//next case
	case 1: 
		break;

	case 0:  umsg(); err(ERR_BADPAR, "can not be zero agrs", "cmdline");
	default: umsg(); err(ERR_BADPAR, "too many args", "cmdline");
	}

	fprintf(stderr,
		"pra -%s %s\n", // %s %s\n",
		(cmdline_params.is_pri? "primary": "secondary"),
		cmdline_params.fc_fname
		//cmdline_params.fi_fname,
		//cmdline_params.fo_fname
		);

	//
	fcw= fcr= 0;

	#if 0
	fi= fopen(cmdline_params.fi_fname,"rb"); if(!fi){ fprintf( stderr, "can not open file '%s' to read, file ignored\n",cmdline_params.fi_fname); }
	
	fo= fopen(cmdline_params.fo_fname,"ab+"); if(!fo)err(ERR_FILE,"open file to append","main",cmdline_params.fo_fname); fclose(fo);
	fo= fopen(cmdline_params.fo_fname,"rb+"); if(!fo)err(ERR_FILE,"open file to write","main",cmdline_params.fo_fname);
	if( fseek(fo, 0, SEEK_END) )err(ERR_FILE,"fseek file to append","main");
	#else
	fi= stdin;
	fo= stdout;

	//  
	is_rx_console= 0;
	if(_beginthread(read_console_thread, 0, 0) == -1L)err(ERR_BADRES, "_beginthread read_console_thread", "main");
	#endif

	//**********
	//primary
	if(cmdline_params.is_pri){
	
	//struct timespec 
	//	ts;

	// 
	//init_timer();

	// 
	//(pra_conf.init_timer_tx_line)
	timer_tx_line.init_value= 10; 
	//(pra_conf.pri_init_timer_no_reply)
	timer_tx_no_reply.init_value= 30; 

	uint
		pauses= 0,
		to_tx= 0,
		to_rx= 0;

	DWORD
		last;

	HANDLE
		h_file;

	//
	h_file= CreateFile( 
         cmdline_params.fc_fname,   	// pipe name 
         GENERIC_READ |  				
         GENERIC_WRITE,                 // read and write access 
         //0,
         FILE_SHARE_READ |
         FILE_SHARE_WRITE,              // sharing 
         NULL,           				// default security attributes
         OPEN_EXISTING,  				// opens existing pipe 
         FILE_FLAG_NO_BUFFERING |
         FILE_FLAG_OVERLAPPED,			// attributes 
         NULL);          				// no template file 

	if(h_file == INVALID_HANDLE_VALUE)err(ERR_FILE,"CreateFile pipe for tx/rx","main",cmdline_params.fc_fname);

	OVERLAPPED
		o_tx,
		o_rx;
	
	o_tx.hEvent= CreateEvent(0,TRUE,TRUE,0); if(!o_tx.hEvent)err(ERR_BADRES,"CreateEvent","o_tx");
	o_rx.hEvent= CreateEvent(0,TRUE,TRUE,0); if(!o_rx.hEvent)err(ERR_BADRES,"CreateEvent","o_rx");

	timer_tx_line.is_timeout= 0;
	timer_tx_no_reply.is_timeout= 0;

	bool
		//    
		is_wr= 1,
		//       
		is_rd= 1;

	//
	int
		tx_ch= PR_SYN,
		rx_ch= PR_SYN;

	//
	for(uint u= 0;;){

		//fprintf(stderr,"\r");

		//**********
		//tx
		//   WriteFile     overlapped IO
		// WriteFile  CancelIoEx   timeout

		//if(!fi)PR_SYN
		//tx_ch= fi? fgetc(fi): PR_SYN; 
		//if(tx_ch == EOF){ if( feof(fi) )tx_ch= PR_SYN; else err(ERR_FILE,"fgetc fi","main"); }
		tx_ch= PR_SYN;

		if(is_rx_console){
			tx_ch= rx_console_data;
			is_rx_console= 0;
		}

		//    thread     
		//if(fputc(tx_ch,fcw) == EOF)err(ERR_FILE,"fputc pipe","main"); 
		is_wr= 0;
		if( !WriteFile(
				h_file,
				&tx_ch,
				1,
				0,
				&o_tx
				)){
			last= GetLastError(); 
			if(last != ERROR_IO_PENDING)win_err(last,ERR_FILE,"WriteFile tx_ch","main");
		}

		//timer_tx_line
		timer_tx_line.is_timeout= 0;
		switch( WaitForSingleObject(o_tx.hEvent, timer_tx_line.init_value*30 ) ){
			case WAIT_OBJECT_0:	
				//write completed OK 
				is_wr= 1; 
				//fprintf(stderr," tx3\n");
				break; 

			case WAIT_TIMEOUT:	
				{
				timer_tx_line.is_timeout= 1; 
				++to_tx; 

				//     
				{
				if( !CancelIoEx(h_file,&o_tx) ){
					last= GetLastError(); 
					if(last != ERROR_NOT_FOUND)win_err(last,ERR_FILE,"CancelIoEx tx_ch","main");
				}
				//Wait for the I/O subsystem to acknowledge our cancellation
				GetOverlappedResult( h_file, &o_tx, &last, TRUE );
				}

				}break;
			default: err(ERR_FILE,"WaitForSingleObject tx_ch","main"); 
		}

		//**********
		//rx
		//   tx
		
		if(
			//  ReadFile       WriteFile
			//  is_wr
			(is_wr)

			//  ReadFile     ReadFile
			// ReadFile    CancelIoEx   timeout
			//   WaitForSingleObject  is_rd
			//  is_rd
			&&(is_rd)
			)
		{

		is_rd= 0;
		if( !ReadFile(
				h_file,
				&rx_ch,
				1,
				0,
				&o_rx
				)){
			last= GetLastError(); 
			if(last != ERROR_IO_PENDING)win_err(last,ERR_FILE,"ReadFile rx_ch","main");
		}}

		//    ReadFile   
		//  !is_rd
		if(!is_rd)
		{
		timer_tx_no_reply.is_timeout= 0;
		switch( WaitForSingleObject(o_rx.hEvent, timer_tx_no_reply.init_value*30 ) ){
			case WAIT_OBJECT_0:	
				//read completed OK 
				is_rd= 1; 

				// rx    
				if(rx_ch != PR_SYN){ if( fputc(rx_ch,fo) == EOF )err(ERR_FILE,"fputc fo","main"); }

				break; 
			case WAIT_TIMEOUT:	
				timer_tx_no_reply.is_timeout= 1; 
				++to_rx; 
				// timeout    ,    
				break;
			default: err(ERR_FILE,"WaitForSingleObject rx_ch","main"); 
		}}

		//check pause SYN/SYN
		if( 
			//  
			(is_wr)
			//  
			&&(is_rd)
			//  SYN/SYN
			&&(tx_ch == PR_SYN && rx_ch == PR_SYN)
			){ 
			++pauses; 

			//(pra_conf.pri_init_timer_keep_alive * pra_conf.timer_step)
			//SleepEx(30,FALSE);
			//usleep(1000 * 30); 
			//struct timespec ts = { 0, 1000L*1000L*30 };
			//ts.tv_sec= 0; 
			//ts.tv_nsec= 1000L*1000L*(1*30);
			//nanosleep(&ts, 0);
			Sleep(30);
		}

		//**********
		//
		#if 0
		++u;
		fprintf(
			stderr,"\rpass: %07lu (rx:0x%02lx, tx:0x%02lx), (pa:0x%04lx, to_rx:0x%04lx, to_tx:0x%04lx)", 
			u, 
			(0x00FFU&rx_ch),
			(0x00FFU&tx_ch),
			(0x00FFU&pauses),
			(0x00FFU&to_rx),
			(0x00FFU&to_tx)
			);
		#endif

	//secondary
	}}else{

	//
	// "rb+" (dup  "w"     "rb+") 
	//	    fcntl  dup 
	//	        ,    
	fcw= fopen(cmdline_params.fc_fname,"rb+"); if(!fcw)err(ERR_FILE,"fopen pipe for tx","main",cmdline_params.fc_fname);
	fcr= fdup_pipe(fcw,"rb"); if(!fcr)err(ERR_FILE,"fdopen pipe for rx","main",cmdline_params.fc_fname);
	
	//     
	if( setvbuf(fcw, 0, _IONBF, 0) )err(ERR_FILE,"setvbuf pipe tx to _IONBF","main");
	if( setvbuf(fcr, 0, _IONBF, 0) )err(ERR_FILE,"setvbuf pipe rx to _IONBF","main");

	for(uint u= 0;;){

		//**********
		//rx
		int
			rx_ch= fgetc(fcr); 
		if(rx_ch == EOF){ if( feof(fcr) )break; else err(ERR_FILE,"fgetc pipe","main"); }

		if(rx_ch != PR_SYN){ if( fputc(rx_ch,stdout) == EOF )err(ERR_FILE,"fputc stdout","main"); }

		//**********
		//tx
		#if 0
		int
			//if(!fi)PR_SYN
			tx_ch= fi? fgetc(fi): PR_SYN; 
		if(tx_ch == EOF){ if( feof(fi) )tx_ch= PR_SYN; else err(ERR_FILE,"fgetc fi","main"); }
		#endif
		int
			tx_ch= PR_SYN;

		if(is_rx_console){
			tx_ch= rx_console_data;
			is_rx_console= 0;
		}

		if(fputc(tx_ch,fcw) == EOF)err(ERR_FILE,"fputc pipe","main"); 

		//**********
		//
		#if 0
		++u;
		fprintf(
			stderr,"\rpass: %07u (rx: 0x%02x, tx: 0x%02x)",
			u, 
			(0x00FFU&rx_ch),
			(0x00FFU&tx_ch)
			);
		#endif
	}}
	fprintf(stderr,"\n");
}
