#ifndef ADEF_H
#define ADEF_H
//   ++

// 
#ifdef PRA_DOS

#define BEGIN_namespace(name) 	//namespace name{
#define BEGIN_namespace_a 		//namespace{
#define END_namespace(name)		//}//namespace name
#define END_namespace_a 		//}//namespace
#define REF_namespace(name)		//name::
#define USING_namespace(name)	//using namespace name;

typedef char			bool;

// 
#else

#define BEGIN_namespace(name) 	namespace name{
#define BEGIN_namespace_a 		namespace{
#define END_namespace(name)		}//namespace name
#define END_namespace_a			}//namespace
#define REF_namespace(name)		name::
#define USING_namespace(name)	using namespace name;

#endif

//       
//   
#define ctor_explicit 			bool const

//namespace Ndef{
BEGIN_namespace(Ndef)

//win32
typedef unsigned char	ureg8;
typedef unsigned short	ureg16;
typedef unsigned long	ureg32;

typedef char			reg8;
typedef short			reg16;
typedef long			reg32;

typedef unsigned char	uchar;
typedef unsigned short	ushort;
typedef unsigned long	ulong;

typedef unsigned int	uint;

//
enum{
	ERR_NO= 0,

	ERR_ZPTR,
	ERR_BOUND,
	ERR_BADPAR,

	ERR_RES_ZPTR,
	ERR_RES_BOUND,
	ERR_BADRES,

	ERR_NOMEM,
	ERR_FILE,
	ERR_NET,

	ERR_NOT_IMPL, 

	ERR_USRDEF= 256,
	ERR_COMXT
};

void
	err(
		ushort const e,
		char const *const msg=0,
		char const *const who=0,
		char const *const what=0
		);

//
//split FILE for 'r'/'rb+' separated access for pipes
//	 dup  lseek   ""  handle 
//	 fdup_pipe_r   interleave r/w    pipes 
//	(..  pipes   lseek)
//return "r" mode dupped fr from original "r+"("w") mode fw
FILE
	*fdup_pipe(
		FILE *const fw,
		//"rb"|"rb+"
		char const *const mode
		);

//
//    
//	         
//	      (     )
//	    
//   main   
void
	complete_static_init();

//namespace Ndef
END_namespace(Ndef)
#endif