#ifndef T1_D_H
#define T1_D_H
//     DOS

//namespace NprA{
BEGIN_namespace(NprA)

//
// com_port  main  parse_cmdline
class Tmain_com_port{
public:
	ureg8
		//idx 0-3 uart    [DOS_COM_PORTS] 
		com_idx;
	bool
		// com_port  primary|secondary  
		is_pri;
	ureg16
		//    no_reply   (primary only) 
		pri_init_timer_no_reply;

	char const 
		//     
		*fi,
		//     
		*fo;

public:
		Tmain_com_port(): com_idx(0), is_pri(1), pri_init_timer_no_reply(900/50), fi(0), fo(0) {}

		Tmain_com_port(
			ureg8 const ci, 
			bool const ip, 
			ureg16 const nr, 
			char const *const pfi, 
			char const *const pfo
		): 
		com_idx(ci), is_pri(ip), pri_init_timer_no_reply(nr), fi(pfi), fo(pfo) {}
};	

extern
Tmain_com_port
	params;

//
void
	umsg();

void
	display_cmdline();

//
Tmain_com_port
	parse_cmdline(
		int argc,
		char *argv[]
		);

// CTRL+
extern
bool
	//  CTRL+
	// SIGINT    
	//            CTRL+
	volatile
	is_break_pressed;

void
	//  SIGINT ( INT23)
	SIGINT_handler( 
		int sig 
		);

//namespace NprA
END_namespace(NprA)
#endif
