#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "src/adef.h"
USING_namespace(Ndef)
#include "src/pra.h"

#include "src/pra_st.h"
USING_namespace(NprA)

//
	REF_namespace(NprA)
	TprA_stat::
	TprA_stat():
		total_time(0)
		{

	total_time= time(0);
	reset();
}

//
void
	REF_namespace(NprA)
	TprA_stat::
	reset(
		){

	//  
	rx= 0;
	rx_DLE= 0;
	rx_SYN= 0;

	rx_err_DLE= 0;
	rx_err_line= 0;
	
	rx_err_buf_over= 0;
	rx_err_buf_over_2= 0;
		
	tx= 0;
	tx_DLE= 0;
	tx_SYN= 0;

	tx_err_line= 0;

	UART_err= 0;
	com_err= 0;
	timer_err= 0;
	unk_err= 0;

	passed= 0;
	passed_SYN= 0;
	passed_SYN_SYN= 0;

	st_time= time(0);

	//  
	tx_no_reply= 0;

	paused= 0;
	resumed_by_keep_alive= 0;
}

//
char*
	REF_namespace(NprA)
	TprA_stat::
	pri_sprint80(
		char *const outbuf
		)const{

	if(!outbuf) return outbuf;

	//  801 \r%s
	//t:00000000 r:00000000 p:00000000 |d:000000 l:000000 o:000000+000000 i:000000
	sprintf(outbuf,
		"t:%08lx r:%08lx p:%08lx |d:%06lx l:%06lx o:%06lx%c%06lx i:%06lx",
		(tx + tx_DLE + tx_SYN),
		(rx + rx_DLE + rx_SYN),
		(resumed_by_keep_alive),

		(rx_err_DLE & 0x00FFFFFFUL),
		(rx_err_line & 0x00FFFFFFUL),
		(rx_err_buf_over & 0x00FFFFFFUL), '+', (rx_err_buf_over_2 & 0x00FFFFFFUL),
		(tx_no_reply & 0x00FFFFFFUL)
		);

	return outbuf;
}

//
char*
	REF_namespace(NprA)
	TprA_stat::
	sec_sprint80(
		char *const outbuf
		)const{

	if(!outbuf) return outbuf;

	//  801 \r%s
	//tx:0000000000 rx:0000000000 |re:0000 ro:0000000000
	sprintf(outbuf,
		"t:%08lx r:%08lx |d:%06lx l:%06lx o:%06lx%c%06lx",
		(tx + tx_DLE + tx_SYN),
		(rx + rx_DLE + rx_SYN),

		(rx_err_DLE & 0x00FFFFFFUL),
		(rx_err_line & 0x00FFFFFFUL),
		(rx_err_buf_over & 0x00FFFFFFUL), '+', (rx_err_buf_over_2 & 0x00FFFFFFUL)
		);

	return outbuf;
}
